import Vue from 'vue';
import ElementUI from 'element-ui';
import App from './App.vue';
import router from './router';
import store from './store';
import 'element-ui/lib/theme-chalk/index.css';

Vue.use(ElementUI);
Vue.config.productionTip = false;

const whileList = ['/'] // 设置不需要校验的白名单

router.beforeEach(async (to, from, next) => {
  Vue.prototype.AjaxService.clearQueue()

  if (whileList.includes(to.name)) {
    return next() // 此处需要 return ，否则后面将会被执行
  }

  const needLogin = to.matched.some(route => route.meta.needLogin)
  const isLogin = await store.dispatch('validate')

  if (needLogin) {
    if (isLogin) {
      if (to.name === 'login') next('/')
      else next()
    } else {
      next('/login')
    }
  } else {
    if (to.name === 'login' && isLogin) next('/')
    else next()
  }
})

new Vue({
  router,
  store,
  render: h => h(App)
}).$mount('#app');
